% demo4.m - cross correlation demo with seq14

clear
colormap( gray(256) );


% define input sequence
ifmt = 'seq/im.%06d.ppm';
trange = [0, 30, 60]; % 0:1500;

% define target location
x1 = 81;
x2 = 144;
y1 = 120;
y2 = 155;

% read first image
im = double(pnmread( sprintf( ifmt, trange(1) ) ));   % read image
I = 0.299*im(:,:,1) + 0.587*im(:,:,2) + 0.114*im(:,:,3);
image( I+1 );
[nr, nc] = size(I);

% extract target
T = I(y1:y2, x1:x2);

% display the results
Idisplay = I;
Idisplay( y1:y2, [x1 x2]) = 255;
Idisplay([y1 y2], x1:x2 ) = 255;
image( Idisplay + 1 );


for indx = 2:length(trange)
    t = trange(indx);
    
    % read nex image
    im = double(pnmread( sprintf( ifmt, trange(indx) ) ));   % read image
    I = 0.299*im(:,:,1) + 0.587*im(:,:,2) + 0.114*im(:,:,3);
    
    % do correlation
    M = conv2( I, T(end:-1:1, end:-1:1), 'same' );  % compute correlation

    % find max
    [row, col] = find( M == max(max(M)) );
    
    % display the results
    Idisplay = I;
    Idisplay( row-7:row+7, col ) = 255;
    Idisplay( row, col-7:col+7 ) = 255;
    xm = 0.5 * (x1 + x2);
    ym = 0.5 * (y1 + y2);
    x1 = round( x1 - xm + col );
    x2 = round( x2 - xm + col );
    y1 = round( y1 - ym + row );
    y2 = round( y2 - ym + row );
    Idisplay( y1:y2, [x1 x2]) = 255;
    Idisplay([y1 y2], x1:x2 ) = 255;
    image( Idisplay + 1 );
end
