% demo7.m - pyramid normalized cross correlation with seq14

clear
colormap( gray(256) );

% define input sequence
ifmt = 'seq/im.%06d.ppm';
trange = [0, 30, 60]; % 0:1500;

% define target location
x1 = 81;
x2 = 144;
y1 = 120;
y2 = 155;
dx = x2 - x1;
dy = y2 - y1;



% read first image
im = double(pnmread( sprintf( ifmt, trange(1) ) ));   % read image
I = 0.299*im(:,:,1) + 0.587*im(:,:,2) + 0.114*im(:,:,3);
image( I+1 );
[nr, nc] = size(I);

% extract target
T = I(y1:y2, x1:x2);

% display the results
Idisplay = I;
Idisplay( y1:y2, [x1 x2]) = 255;
Idisplay([y1 y2], x1:x2 ) = 255;
image( Idisplay + 1 );


for indx = 2:length(trange)
    t = trange(indx);
    
    % read nex image
    im = double(pnmread( sprintf( ifmt, trange(indx) ) ));   % read image
    I = 0.299*im(:,:,1) + 0.587*im(:,:,2) + 0.114*im(:,:,3);
    
    % find correlation peak with pyramid method
   [row, col] = nxcorrfind( I, T );
    
    % display the results
    Idisplay = I;
    x1 = col;
    x2 = x1 + dx;
    y1 = row;
    y2 = y1 + dy;
    Idisplay( y1:y2, [x1 x2]) = 255;
    Idisplay([y1 y2], x1:x2 ) = 255;
    xc = round( 0.5 * (x1 + x2) );
    yc = round( 0.5 * (y1 + y2) );
    Idisplay( yc-7:yc+7, xc ) = 255;
    Idisplay( yc, xc-7:xc+7 ) = 255;
    image( Idisplay + 1 );
end
